START-STOP-DAEMON(8)

NAME
start-stop-daemon - start and stop system daemon programs

SYNOPSIS
start-stop-daemon -S|--start options [--] arguments

start-stop-daemon -K|--stop options

start-stop-daemon -H|--help

start-stop-daemon -V|--version

DESCRIPTION
start-stop-daemon is used to control the creation and termination of system-level processes. Using the --exec, --pidfile, --user, and --name options, start-stop-daemon can be configured to find existing instances of a running process. With --start, start-stop-daemon checks for the existence of a specified process. If such a process exists, start-stop-daemon does nothing, and exits with error status 1 (0 if --oknodo is specified). If such a process does not exist, it starts an instance, using either the executable specified by --exec, (or, if specified, by --startas). Any arguments given after -- on the command line are passed unmodified to the program being started. If --retry is specified then start-stop-daemon will check that the process(es) have terminated. With --stop, start-stop-daemon also checks for the existence of a specified process. If such a process exists, start-stop-daemon sends it the signal specified by --signal, and exits with error status 0. If such a process does not exist, start-stop-daemon exits with error status 1 (0 if --oknodo is specified).

OPTIONS

-x|--exec executable
    Check for processes that are instances of this executable (according to /proc/pid/exe ).

-p|--pidfile pid-file
    Check for processes whose process-id is specified in pid-file.

-u|--user username|uid
    Check for processes owned by the user specified by username or uid.

-n|--name process-name
    Check for processes with the name process-name (according to /proc/pid/stat).

-s|--signal signal
    With --stop, specifies the signal to send to processes being stopped (default 15).

-R|--retry timeout|schedule
    With --stop, specifies that start-stop-daemon is to check whether the process(es) do finish. It will check repeatedly whether any matching processes are running, until none are. If the processes do not exit it will then take further action as determined by the schedule. If timeout is specified instead of schedule then the schedule signal/timeout/KILL/timeout is used, where signal is the signal specified with --signal. schedule is a list of at least two items separated by slashes (/); each item may be -signal-number or [-]signal-name, which means to send that signal, or timeout, which means to wait that many seconds for processes to exit, or forever, which means to repeat the rest of the schedule forever if necessary. If the end of the schedule is reached and forever is not specified, then start-stop-daemon exits with error status 2. If a schedule is specified, then any signal specified with --signal is ignored.

-a|--startas pathname
    With --start, start the process specified by pathname. If not specified, defaults to the argument given to --exec.

-t|--test
    Print actions that would be taken and set appropriate return value, but take no action.

-o|--oknodo
    Return exit status 0 instead of 1 if no actions are (would be) taken.

-q|--quiet
    Do not print informational messages; only display error messages.

-c|--chuid username|uid
    Change to this username/uid before starting the process. You can also specify a group by appending a :, then the group or gid in the same way as you would for the `chown' command (user:group). When using this option you must realize that the primary and supplemental groups are set as well, even if the --group option is not specified. The --group option is only for groups that the user isn't normally a member of (like adding per/process group membership for generic users like nobody).

-r|--chroot root
    Chdir and chroot to root before starting the process. Please note that the pidfile is also written after the chroot.

-b|--background
    Typically used with programs that don't detach on their own. This option will force start-stop-daemon to fork before starting the process, and force it into the background. WARNING: start-stop-daemon cannot check the exit status if the process fails to execute for any reason. This is a last resort, and is only meant for programs that either make no sense forking on their own, or where it's not feasible to add the code for it to do this itself.

-N|--nicelevel
    This alters the prority of the process before starting it.

-m|--make-pidfile
    Used when starting a program that does not create its own pid file. This option will make start-stop-daemon create the file referenced with --pidfile and place the pid into it just before executing the process. Note, it will not be removed when stopping the program. NOTE: This feature may not work in all cases. Most notably when the program being executed forks from its main process. Because of this it is usually only useful when combined with the --background option.

-v|--verbose
    Print verbose informational messages.

-H|--help
    Print help information; then exit.

-V|--version
    Print version information; then exit.

AUTHORS
Marek Michalkiewicz <marekm@i17linuxb.ists.pwr.wroc.pl> based on a previous version by Ian Jackson <ian@chiark.greenend.org.uk>. Manual page by Klee Dienes <klee@mit.edu>, partially reformatted by Ian Jackson.